%{

/*
   timing.l -- PIKT piktd timing lexer

   $Header: /var/cvs/PIKT/pikt/src/piktd/timing.l,v 1.24 2007/01/18 13:17:31 berto Exp $

   This file is part of PIKT ("Problem Informant/Killer Tool").
   Copyright (C) 1998-2007 by Robert Osterlund.

   PIKT is a trademark of the University of Chicago.  All Rights Reserved.

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   PIKT is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
   USA.

   Send problem reports, bouquets and brickbats to:  pikt-bugs@pikt.org
 */

#include "../lib/common.h"

#include "piktd.h"
#include "timing.tab.h"

#undef YY_INPUT
#define YY_INPUT(buf, result, max_size) { \
		signed char c = timinginput(); \
		result = (c == EOF) ? YY_NULL : (buf[0] = c, 1); \
	}

void timingerror(const char *);
signed int timinginput(void);

%}

W		[ \t]
D		[0-9]
L		[A-Za-z]
DL		[0-9A-Za-z]

%option noyywrap

%%

{D}+				{ timinglval.ival = atoi(yytext);
				  return _NUMBER;
				}

(\*|\-|\,|\/|\%)		{ return yytext[0]; }

.				{ return yytext[0]; }

%%

/* timing error handler
 */
void
timingerror (const char *message)
{

	logexit(PIKTLOG, LOG_ERR, ERRID_TIMING_PARSE_ERROR, __FILE__, __LINE__, "timingparse", FALSE, "%s: @%s@", message, yytext ? yytext : nullstring);
	return;
}

/* feed timing params to the input stream
 */
signed int
timinginput (void)
{
	register char c;

	if (! *tcp) {
		return(EOF);
	}
	c = *tcp;
	tcp++;
	return(c);
}
